package betterwithmods.common.blocks.tile;

import betterwithmods.module.hardcore.crafting.HCFurnace;

import java.util.Map.Entry;

import net.minecraft.block.BlockFurnace;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntityFurnace;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.registry.GameRegistry.ItemStackHolder;
import net.minecraftforge.items.ItemHandlerHelper;
import net.minecraftforge.oredict.OreDictionary;

//Borrowing caching logic from https://github.com/Shadows-of-Fire/FastFurnace

public class TileFurnace extends TileEntityFurnace {

    public static final int INPUT = 0;
    public static final int FUEL = 1;
    public static final int OUTPUT = 2;

    protected ItemStack recipeKey = ItemStack.field_190927_a;
    protected ItemStack recipeOutput = ItemStack.field_190927_a;
    protected ItemStack failedMatch = ItemStack.field_190927_a;


    @ItemStackHolder(value = "minecraft:sponge", meta = 1)
    public static final ItemStack WET_SPONGE = ItemStack.field_190927_a;

    public TileFurnace() {
        this.field_174905_l = 200;
    }


    @Override
    public int func_174904_a(ItemStack stack) {
        return HCFurnace.getCookingTime(stack).orElse(200);
    }

    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound compound) {
        compound = super.func_189515_b(compound);
        compound.func_74768_a("BurnTime", this.field_145956_a);
        compound.func_74768_a("CookTime", this.field_174906_k);
        compound.func_74768_a("CookTimeTotal", this.field_174905_l);
        return compound;
    }

    @Override
    public void func_73660_a() {
        if (field_145850_b.field_72995_K && func_145950_i()) {
            field_145956_a--;
            return;
        } else if (field_145850_b.field_72995_K) return;

        ItemStack fuel = ItemStack.field_190927_a;
        boolean canSmelt = func_145948_k();

        if (!this.func_145950_i() && !(fuel = field_145957_n.get(FUEL)).func_190926_b()) {
            burnFuel(fuel, false);
        }

        boolean wasBurning = func_145950_i();

        if (this.func_145950_i()) {
            field_145956_a--;
            if (canSmelt) smelt();
            else field_174906_k = 0;
        }

        if (!this.func_145950_i() && !(fuel = field_145957_n.get(FUEL)).func_190926_b()) {
            burnFuel(fuel, wasBurning);
        }

        if (wasBurning && !func_145950_i())
            field_145850_b.func_175656_a(field_174879_c, Blocks.field_150460_al.func_176223_P().func_177226_a(BlockFurnace.field_176447_a, field_145850_b.func_180495_p(field_174879_c).func_177229_b(BlockFurnace.field_176447_a)));
    }

    private void smelt() {
        field_174906_k++;
        if (this.field_174906_k == this.field_174905_l) {
            this.field_174906_k = 0;
            this.field_174905_l = this.func_174904_a(this.field_145957_n.get(INPUT));
            this.func_145949_j();
        }
    }

    private void burnFuel(ItemStack fuel, boolean burnedThisTick) {
        field_145963_i = (field_145956_a = func_145952_a(fuel));
        if (this.func_145950_i()) {
            fuel.func_190918_g(1);
            if (fuel.func_190926_b()) field_145957_n.set(FUEL, fuel.func_77973_b().getContainerItem(fuel));
            if (!burnedThisTick)
                field_145850_b.func_175656_a(field_174879_c, Blocks.field_150470_am.func_176223_P().func_177226_a(BlockFurnace.field_176447_a, field_145850_b.func_180495_p(field_174879_c).func_177229_b(BlockFurnace.field_176447_a)));
        }
    }


    public boolean func_145948_k() {
        ItemStack input = field_145957_n.get(INPUT);
        ItemStack output = field_145957_n.get(OUTPUT);
        if (input.func_190926_b() || input == failedMatch) return false;

        if (recipeKey.func_190926_b() || !OreDictionary.itemMatches(recipeKey, input, false)) {
            boolean matched = false;
            for (Entry<ItemStack, ItemStack> e : FurnaceRecipes.func_77602_a().func_77599_b().entrySet()) {
                if (OreDictionary.itemMatches(e.getKey(), input, false)) {
                    recipeKey = e.getKey();
                    recipeOutput = e.getValue();
                    matched = true;
                    failedMatch = ItemStack.field_190927_a;
                    break;
                }
            }
            if (!matched) {
                recipeKey = ItemStack.field_190927_a;
                recipeOutput = ItemStack.field_190927_a;
                failedMatch = input;
                return false;
            }
        }

        return !recipeOutput.func_190926_b() && (output.func_190926_b() || (ItemHandlerHelper.canItemStacksStack(recipeOutput, output) && (recipeOutput.func_190916_E() + output.func_190916_E() <= output.func_77976_d())));
    }

    @Override
    public void func_145949_j() {
        ItemStack input = this.field_145957_n.get(INPUT);
        ItemStack recipeOutput = FurnaceRecipes.func_77602_a().func_77599_b().get(recipeKey);
        ItemStack output = this.field_145957_n.get(OUTPUT);

        if (output.func_190926_b()) this.field_145957_n.set(OUTPUT, recipeOutput.func_77946_l());
        else if (ItemHandlerHelper.canItemStacksStack(output, recipeOutput)) output.func_190917_f(recipeOutput.func_190916_E());

        if (input.func_77969_a(WET_SPONGE) && this.field_145957_n.get(FUEL).func_77973_b() == Items.field_151133_ar)
            this.field_145957_n.set(FUEL, new ItemStack(Items.field_151131_as));

        input.func_190918_g(1);
    }

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, IBlockState oldState, IBlockState newState) {
        if (oldState.func_177230_c() == Blocks.field_150460_al && newState.func_177230_c() == Blocks.field_150470_am) return false;
        else if (oldState.func_177230_c() == Blocks.field_150470_am && newState.func_177230_c() == Blocks.field_150460_al) return false;
        return true;
    }
}
